/*******************************************************************************
 * Project:
 *  "Audioprocessor"
 * 
 * Version / Date:
 *  2.3 / Januar 2018
 * 
 * Authors:
 *  Markus Hufschmid, Simon Gerber, Belinda Kneubuehler
 * 
 * File Name:
 *  twiddleFactors.c
 * 
 * Description:
 *  Definition of twiddle factors for fft.
*******************************************************************************/
#include <dsp.h>
#include "fft.h"


const fractcomplex __attribute__ ((space(auto_psv), aligned (FFT_BLOCK_LENGTH*2))) twiddleFactors[FFT_BLOCK_LENGTH/2] = {
//const fractcomplex __attribute__ ((space(auto_psv))) twiddleFactors[FFT_BLOCK_LENGTH/2] = {
//__attribute__ ((aligned (FFT_BLOCK_LENGTH*2)))= {
        {0x7FFF, 0x0000}, {0x7FD9, 0xF9B8}, {0x7F62, 0xF374}, {0x7E9D, 0xED38},
        {0x7D8A, 0xE707}, {0x7C2A, 0xE0E6}, {0x7A7D, 0xDAD8}, {0x7885, 0xD4E1},
        {0x7642, 0xCF04}, {0x73B6, 0xC946}, {0x70E3, 0xC3A9}, {0x6DCA, 0xBE32},
        {0x6A6E, 0xB8E3}, {0x66D0, 0xB3C0}, {0x62F2, 0xAECC}, {0x5ED7, 0xAA0A},
        {0x5A82, 0xA57E}, {0x55F6, 0xA129}, {0x5134, 0x9D0E}, {0x4C40, 0x9930},
        {0x471D, 0x9592}, {0x41CE, 0x9236}, {0x3C57, 0x8F1D}, {0x36BA, 0x8C4A},
        {0x30FC, 0x89BE}, {0x2B1F, 0x877B}, {0x2528, 0x8583}, {0x1F1A, 0x83D6},
        {0x18F9, 0x8276}, {0x12C8, 0x8163}, {0x0C8C, 0x809E}, {0x0648, 0x8027},
        {0x0000, 0x8000}, {0xF9B8, 0x8027}, {0xF374, 0x809E}, {0xED38, 0x8163},
        {0xE707, 0x8276}, {0xE0E6, 0x83D6}, {0xDAD8, 0x8583}, {0xD4E1, 0x877C},
        {0xCF04, 0x89BE}, {0xC946, 0x8C4A}, {0xC3A9, 0x8F1D}, {0xBE32, 0x9236},
        {0xB8E3, 0x9592}, {0xB3C0, 0x9931}, {0xAECC, 0x9D0E}, {0xAA0A, 0xA129},
        {0xA57E, 0xA57E}, {0xA129, 0xAA0A}, {0x9D0E, 0xAECC}, {0x9931, 0xB3C0},
        {0x9592, 0xB8E3}, {0x9236, 0xBE32}, {0x8F1D, 0xC3A9}, {0x8C4A, 0xC946},
        {0x89BE, 0xCF04}, {0x877C, 0xD4E1}, {0x8583, 0xDAD8}, {0x83D6, 0xE0E6},
        {0x8276, 0xE707}, {0x8163, 0xED38}, {0x809E, 0xF374}, {0x8027, 0xF9B8}
};

